function shdel__shiftDelete() {
  shdel__debug("func START");
    
  try {

    var myPrefs = shdel__getMyPrefs();
    
    if (myPrefs == null) {
      shdel__debug("no myprefs!");
      return;
    }
    
    state = shdel__getCharPref(myPrefs, "key_state", "disable");
    shdel__debug("state=" + state);
    
    switch(state) {
    case "disable":
      shdel__debug("in disabled state");
      return;
	
    case "shift-delete":
      shdel__debug("in shift-delete state");
      goDoCommand("cmd_shiftDelete");
      return;
	
    case "delete":
      shdel__debug("in delete state");
      goDoCommand("cmd_delete");
      return;
    }
    
    // smart:
    var smartMsgNum = shdel__getIntPref(myPrefs, "smart_silent_del", -1);
    shdel__debug("smartMsgNum=" + smartMsgNum);
    var selectedAmount = shdel__get_selected_msgs_amount();
    if (smartMsgNum > 0 && selectedAmount > smartMsgNum) {
      shdel__debug("smart: WARN");
      if(confirm ("Really purge " + selectedAmount + " messages ?"))
	goDoCommand("cmd_shiftDelete");
    }
    else {
      shdel__debug("smart: SILENT SH-del:");
      goDoCommand("cmd_shiftDelete");
    }
  } catch (e) {
    shdel__debug("!!!!shdel__shiftDelete: " + e);
  }
}

function shdel__get_selected_msgs_amount() {
  try {
    var tree = document.getElementById("threadTree");
    var rangeCount = tree.view.selection.getRangeCount();
    var count = 0;
    for(var i=0; i<rangeCount; i++) {
      var start = {};
      var end = {};
      tree.view.selection.getRangeAt(i,start,end);
      
      for(var c=start.value; c<=end.value; c++) {
	++count;
      }
    }    
    
    shdel__debug("count= " + count);
    return count;

  } catch (e) {
    shdel__debug("!!!!!!: " + e);
  }
}



shdel__debug("loaded ok: state=" + shdel__getCharPref(shdel__getMyPrefs(), "key_state", "WRONGDEF"));

